'
''Title: csMusicMedia Pro v3.1 - Example App
'
''By: Jason Hensley
'
''Contact: mailto:jason@vbcodesource.com
'
''Webpage: http://www.vbcodesource.com or http://www.vbcodesource.info
'
''Description: A small, basic example of how to use my new csMusicMedia Pro library in your 
'applications. As you can see, the design of this library makes it VERY easy to use. This example only 
'covers the basic of the library though. There are MANY other features that the library can help you 
'implement. This is of course, very similar to the example app for the csMusicLibrary class but with 
'the usual changes required for VB 2005.
'
''Original Copyright: 2006, January 07
'
''Updated Copyright: 2006, December 01
'
'Final Copyright: 2006, December 04
'
'
Imports System.IO
Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
'
'
Public Class frmMain
    Inherits System.Windows.Forms.Form
    '
    'Create a new instance of the music library. This is the heart of all the
    'functionality for the music application.
    Dim csMusic As csMusicMedia = New csMusicMedia
    '
    'This will hold the path and name of the file that was selected with the File Dialog.
    Dim selectedFile As String = Nothing
    'This will be used for opening a File Open Dialog window to select the file to play.
    Dim openDLG As OpenFileDialog
    '
    Dim startPos As Point
    '
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnStop As System.Windows.Forms.Button
    Friend WithEvents btnPause As System.Windows.Forms.Button
    Friend WithEvents btnPlay As System.Windows.Forms.Button
    Friend WithEvents btnOpen As System.Windows.Forms.Button
    Friend WithEvents lblPositionNormal As System.Windows.Forms.Label
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents t As System.Windows.Forms.Timer
    Friend WithEvents pnl As System.Windows.Forms.Panel
    Friend WithEvents lblDevice As System.Windows.Forms.Label
    Friend WithEvents lblBitrate As System.Windows.Forms.Label
    Friend WithEvents lblPathFilename As System.Windows.Forms.Label
    Friend WithEvents lblFileType As System.Windows.Forms.Label
    Public WithEvents tbPosition As System.Windows.Forms.TrackBar
    Friend WithEvents lblPlayRate As System.Windows.Forms.Label
    Friend WithEvents nSpeed As System.Windows.Forms.NumericUpDown
    Friend WithEvents lblVolume As System.Windows.Forms.Label
    Friend WithEvents nVol As System.Windows.Forms.NumericUpDown
    Friend WithEvents chkMute As System.Windows.Forms.CheckBox
    Friend WithEvents chkMuteRight As System.Windows.Forms.CheckBox
    Friend WithEvents chkMuteLeft As System.Windows.Forms.CheckBox
    Friend WithEvents gbCommands As System.Windows.Forms.GroupBox
    Friend WithEvents gbDisplays As System.Windows.Forms.GroupBox
    Friend WithEvents lblPositionSeconds As System.Windows.Forms.Label
    Friend WithEvents lblPositionMilliseconds As System.Windows.Forms.Label
    Friend WithEvents lblTimeRemaining As System.Windows.Forms.Label
    Friend WithEvents lblTimeRemainingSeconds As System.Windows.Forms.Label
    Friend WithEvents lblBitrateKBits As System.Windows.Forms.Label
    Friend WithEvents lblTimeRemainingMilliseconds As System.Windows.Forms.Label
    Friend WithEvents lblDurationSeconds As System.Windows.Forms.Label
    Friend WithEvents lblDurationMilliseconds As System.Windows.Forms.Label
    Friend WithEvents lblDurationNormal As System.Windows.Forms.Label
    Friend WithEvents tRecording As System.Windows.Forms.Timer
    Friend WithEvents lblRecordingSamplesPerSecond As System.Windows.Forms.Label
    Friend WithEvents gbWaveOnly As System.Windows.Forms.GroupBox
    Friend WithEvents lblChannels As System.Windows.Forms.Label
    Friend WithEvents lblBytesPerSecond As System.Windows.Forms.Label
    Friend WithEvents lblBitsPerSample As System.Windows.Forms.Label
    Friend WithEvents lblRecordingBytesPerSecond As System.Windows.Forms.Label
    Friend WithEvents lblSamplesPerSecond As System.Windows.Forms.Label
    Friend WithEvents lblWavePositionBytes As System.Windows.Forms.Label
    Friend WithEvents lblWaveDurationBytes As System.Windows.Forms.Label
    Friend WithEvents picLogo As System.Windows.Forms.PictureBox
    '
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.btnPlay = New System.Windows.Forms.Button
        Me.btnStop = New System.Windows.Forms.Button
        Me.btnPause = New System.Windows.Forms.Button
        Me.btnOpen = New System.Windows.Forms.Button
        Me.pnl = New System.Windows.Forms.Panel
        Me.picLogo = New System.Windows.Forms.PictureBox
        Me.gbRecordingCommands = New System.Windows.Forms.GroupBox
        Me.lblRecordingBytesPerSecond = New System.Windows.Forms.Label
        Me.btnSelectRecordingFile = New System.Windows.Forms.Button
        Me.lblRecordingSamplesPerSecond = New System.Windows.Forms.Label
        Me.lblRecordingChannels = New System.Windows.Forms.Label
        Me.btnRecordingStop = New System.Windows.Forms.Button
        Me.btnRecordingStart = New System.Windows.Forms.Button
        Me.lblRecordingBitsPerSample = New System.Windows.Forms.Label
        Me.lblRecordingFile = New System.Windows.Forms.Label
        Me.gbCommands = New System.Windows.Forms.GroupBox
        Me.chkMute = New System.Windows.Forms.CheckBox
        Me.chkMuteRight = New System.Windows.Forms.CheckBox
        Me.chkMuteLeft = New System.Windows.Forms.CheckBox
        Me.lblPlayRate = New System.Windows.Forms.Label
        Me.lblVolume = New System.Windows.Forms.Label
        Me.nSpeed = New System.Windows.Forms.NumericUpDown
        Me.tbPosition = New System.Windows.Forms.TrackBar
        Me.nVol = New System.Windows.Forms.NumericUpDown
        Me.gbDisplays = New System.Windows.Forms.GroupBox
        Me.gbWaveOnly = New System.Windows.Forms.GroupBox
        Me.lblWavePositionBytes = New System.Windows.Forms.Label
        Me.lblBytesPerSecond = New System.Windows.Forms.Label
        Me.lblBitsPerSample = New System.Windows.Forms.Label
        Me.lblWaveDurationBytes = New System.Windows.Forms.Label
        Me.lblSamplesPerSecond = New System.Windows.Forms.Label
        Me.lblChannels = New System.Windows.Forms.Label
        Me.lblDeviceType = New System.Windows.Forms.Label
        Me.lblTimeRemainingMilliseconds = New System.Windows.Forms.Label
        Me.lblDurationSeconds = New System.Windows.Forms.Label
        Me.lblDurationMilliseconds = New System.Windows.Forms.Label
        Me.lblDurationNormal = New System.Windows.Forms.Label
        Me.lblBitrateKBits = New System.Windows.Forms.Label
        Me.lblTimeRemaining = New System.Windows.Forms.Label
        Me.lblTimeRemainingSeconds = New System.Windows.Forms.Label
        Me.lblPositionSeconds = New System.Windows.Forms.Label
        Me.lblPositionMilliseconds = New System.Windows.Forms.Label
        Me.lblPathFilename = New System.Windows.Forms.Label
        Me.lblPositionNormal = New System.Windows.Forms.Label
        Me.lblFileType = New System.Windows.Forms.Label
        Me.lblBitrate = New System.Windows.Forms.Label
        Me.lblDevice = New System.Windows.Forms.Label
        Me.lblStatus = New System.Windows.Forms.Label
        Me.t = New System.Windows.Forms.Timer(Me.components)
        Me.tRecording = New System.Windows.Forms.Timer(Me.components)
        Me.pnl.SuspendLayout()
        CType(Me.picLogo, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.gbRecordingCommands.SuspendLayout()
        Me.gbCommands.SuspendLayout()
        CType(Me.nSpeed, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.tbPosition, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nVol, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.gbDisplays.SuspendLayout()
        Me.gbWaveOnly.SuspendLayout()
        Me.SuspendLayout()
        '
        'btnPlay
        '
        Me.btnPlay.BackColor = System.Drawing.Color.Lavender
        Me.btnPlay.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.btnPlay.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnPlay.ForeColor = System.Drawing.Color.DarkOrchid
        Me.btnPlay.Location = New System.Drawing.Point(4, 90)
        Me.btnPlay.Name = "btnPlay"
        Me.btnPlay.Size = New System.Drawing.Size(56, 23)
        Me.btnPlay.TabIndex = 0
        Me.btnPlay.Text = "Play"
        Me.btnPlay.UseVisualStyleBackColor = False
        '
        'btnStop
        '
        Me.btnStop.BackColor = System.Drawing.Color.Lavender
        Me.btnStop.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.btnStop.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnStop.ForeColor = System.Drawing.Color.DarkOrchid
        Me.btnStop.Location = New System.Drawing.Point(66, 90)
        Me.btnStop.Name = "btnStop"
        Me.btnStop.Size = New System.Drawing.Size(56, 23)
        Me.btnStop.TabIndex = 1
        Me.btnStop.Text = "Stop"
        Me.btnStop.UseVisualStyleBackColor = False
        '
        'btnPause
        '
        Me.btnPause.BackColor = System.Drawing.Color.Lavender
        Me.btnPause.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.btnPause.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnPause.ForeColor = System.Drawing.Color.DarkOrchid
        Me.btnPause.Location = New System.Drawing.Point(128, 90)
        Me.btnPause.Name = "btnPause"
        Me.btnPause.Size = New System.Drawing.Size(56, 23)
        Me.btnPause.TabIndex = 2
        Me.btnPause.Text = "Pause"
        Me.btnPause.UseVisualStyleBackColor = False
        '
        'btnOpen
        '
        Me.btnOpen.BackColor = System.Drawing.Color.Lavender
        Me.btnOpen.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.btnOpen.ForeColor = System.Drawing.Color.DarkOrchid
        Me.btnOpen.Location = New System.Drawing.Point(190, 90)
        Me.btnOpen.Name = "btnOpen"
        Me.btnOpen.Size = New System.Drawing.Size(56, 23)
        Me.btnOpen.TabIndex = 10
        Me.btnOpen.Text = "Open"
        Me.btnOpen.UseVisualStyleBackColor = False
        '
        'pnl
        '
        Me.pnl.BackColor = System.Drawing.Color.SteelBlue
        Me.pnl.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnl.Controls.Add(Me.picLogo)
        Me.pnl.Controls.Add(Me.gbRecordingCommands)
        Me.pnl.Controls.Add(Me.gbCommands)
        Me.pnl.Controls.Add(Me.gbDisplays)
        Me.pnl.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.pnl.Location = New System.Drawing.Point(-1, 2)
        Me.pnl.Name = "pnl"
        Me.pnl.Size = New System.Drawing.Size(640, 314)
        Me.pnl.TabIndex = 12
        '
        'picLogo
        '
        Me.picLogo.BackColor = System.Drawing.Color.LightGray
        Me.picLogo.Location = New System.Drawing.Point(8, 242)
        Me.picLogo.Name = "picLogo"
        Me.picLogo.Size = New System.Drawing.Size(298, 58)
        Me.picLogo.TabIndex = 30
        Me.picLogo.TabStop = False
        '
        'gbRecordingCommands
        '
        Me.gbRecordingCommands.BackColor = System.Drawing.Color.SteelBlue
        Me.gbRecordingCommands.Controls.Add(Me.lblRecordingBytesPerSecond)
        Me.gbRecordingCommands.Controls.Add(Me.btnSelectRecordingFile)
        Me.gbRecordingCommands.Controls.Add(Me.lblRecordingSamplesPerSecond)
        Me.gbRecordingCommands.Controls.Add(Me.lblRecordingChannels)
        Me.gbRecordingCommands.Controls.Add(Me.btnRecordingStop)
        Me.gbRecordingCommands.Controls.Add(Me.btnRecordingStart)
        Me.gbRecordingCommands.Controls.Add(Me.lblRecordingBitsPerSample)
        Me.gbRecordingCommands.Controls.Add(Me.lblRecordingFile)
        Me.gbRecordingCommands.Location = New System.Drawing.Point(8, 129)
        Me.gbRecordingCommands.Name = "gbRecordingCommands"
        Me.gbRecordingCommands.Size = New System.Drawing.Size(298, 107)
        Me.gbRecordingCommands.TabIndex = 28
        Me.gbRecordingCommands.TabStop = False
        Me.gbRecordingCommands.Text = "Recording Commands && Information"
        '
        'lblRecordingBytesPerSecond
        '
        Me.lblRecordingBytesPerSecond.AutoSize = True
        Me.lblRecordingBytesPerSecond.BackColor = System.Drawing.Color.SteelBlue
        Me.lblRecordingBytesPerSecond.ForeColor = System.Drawing.Color.Gainsboro
        Me.lblRecordingBytesPerSecond.Location = New System.Drawing.Point(6, 54)
        Me.lblRecordingBytesPerSecond.Name = "lblRecordingBytesPerSecond"
        Me.lblRecordingBytesPerSecond.Size = New System.Drawing.Size(101, 14)
        Me.lblRecordingBytesPerSecond.TabIndex = 4
        Me.lblRecordingBytesPerSecond.Text = "BytesPerSecond: n/a"
        '
        'btnSelectRecordingFile
        '
        Me.btnSelectRecordingFile.BackColor = System.Drawing.Color.Thistle
        Me.btnSelectRecordingFile.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSelectRecordingFile.ForeColor = System.Drawing.Color.DarkViolet
        Me.btnSelectRecordingFile.Location = New System.Drawing.Point(213, 78)
        Me.btnSelectRecordingFile.Name = "btnSelectRecordingFile"
        Me.btnSelectRecordingFile.Size = New System.Drawing.Size(75, 23)
        Me.btnSelectRecordingFile.TabIndex = 29
        Me.btnSelectRecordingFile.Text = "Select File..."
        Me.btnSelectRecordingFile.UseVisualStyleBackColor = False
        '
        'lblRecordingSamplesPerSecond
        '
        Me.lblRecordingSamplesPerSecond.AutoSize = True
        Me.lblRecordingSamplesPerSecond.BackColor = System.Drawing.Color.SteelBlue
        Me.lblRecordingSamplesPerSecond.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRecordingSamplesPerSecond.ForeColor = System.Drawing.Color.Gainsboro
        Me.lblRecordingSamplesPerSecond.Location = New System.Drawing.Point(152, 54)
        Me.lblRecordingSamplesPerSecond.Name = "lblRecordingSamplesPerSecond"
        Me.lblRecordingSamplesPerSecond.Size = New System.Drawing.Size(112, 14)
        Me.lblRecordingSamplesPerSecond.TabIndex = 3
        Me.lblRecordingSamplesPerSecond.Text = "SamplesPerSecond: n/a"
        '
        'lblRecordingChannels
        '
        Me.lblRecordingChannels.AutoSize = True
        Me.lblRecordingChannels.BackColor = System.Drawing.Color.SteelBlue
        Me.lblRecordingChannels.ForeColor = System.Drawing.Color.Gainsboro
        Me.lblRecordingChannels.Location = New System.Drawing.Point(152, 40)
        Me.lblRecordingChannels.Name = "lblRecordingChannels"
        Me.lblRecordingChannels.Size = New System.Drawing.Size(69, 14)
        Me.lblRecordingChannels.TabIndex = 2
        Me.lblRecordingChannels.Text = "Channels: n/a"
        '
        'btnRecordingStop
        '
        Me.btnRecordingStop.BackColor = System.Drawing.Color.Thistle
        Me.btnRecordingStop.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnRecordingStop.ForeColor = System.Drawing.Color.DarkViolet
        Me.btnRecordingStop.Location = New System.Drawing.Point(91, 78)
        Me.btnRecordingStop.Name = "btnRecordingStop"
        Me.btnRecordingStop.Size = New System.Drawing.Size(75, 23)
        Me.btnRecordingStop.TabIndex = 27
        Me.btnRecordingStop.Text = "Stop"
        Me.btnRecordingStop.UseVisualStyleBackColor = False
        '
        'btnRecordingStart
        '
        Me.btnRecordingStart.BackColor = System.Drawing.Color.Thistle
        Me.btnRecordingStart.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnRecordingStart.ForeColor = System.Drawing.Color.Purple
        Me.btnRecordingStart.Location = New System.Drawing.Point(9, 78)
        Me.btnRecordingStart.Name = "btnRecordingStart"
        Me.btnRecordingStart.Size = New System.Drawing.Size(75, 23)
        Me.btnRecordingStart.TabIndex = 26
        Me.btnRecordingStart.Text = "Start"
        Me.btnRecordingStart.UseVisualStyleBackColor = False
        '
        'lblRecordingBitsPerSample
        '
        Me.lblRecordingBitsPerSample.AutoSize = True
        Me.lblRecordingBitsPerSample.BackColor = System.Drawing.Color.SteelBlue
        Me.lblRecordingBitsPerSample.ForeColor = System.Drawing.Color.Gainsboro
        Me.lblRecordingBitsPerSample.Location = New System.Drawing.Point(7, 40)
        Me.lblRecordingBitsPerSample.Name = "lblRecordingBitsPerSample"
        Me.lblRecordingBitsPerSample.Size = New System.Drawing.Size(94, 14)
        Me.lblRecordingBitsPerSample.TabIndex = 1
        Me.lblRecordingBitsPerSample.Text = "BitsPerSample: n/a"
        '
        'lblRecordingFile
        '
        Me.lblRecordingFile.AutoEllipsis = True
        Me.lblRecordingFile.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblRecordingFile.ForeColor = System.Drawing.Color.Black
        Me.lblRecordingFile.Location = New System.Drawing.Point(10, 16)
        Me.lblRecordingFile.Name = "lblRecordingFile"
        Me.lblRecordingFile.Size = New System.Drawing.Size(278, 17)
        Me.lblRecordingFile.TabIndex = 0
        Me.lblRecordingFile.Text = "File:"
        Me.lblRecordingFile.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'gbCommands
        '
        Me.gbCommands.Controls.Add(Me.chkMute)
        Me.gbCommands.Controls.Add(Me.chkMuteRight)
        Me.gbCommands.Controls.Add(Me.chkMuteLeft)
        Me.gbCommands.Controls.Add(Me.lblPlayRate)
        Me.gbCommands.Controls.Add(Me.lblVolume)
        Me.gbCommands.Controls.Add(Me.nSpeed)
        Me.gbCommands.Controls.Add(Me.tbPosition)
        Me.gbCommands.Controls.Add(Me.nVol)
        Me.gbCommands.Controls.Add(Me.btnPlay)
        Me.gbCommands.Controls.Add(Me.btnStop)
        Me.gbCommands.Controls.Add(Me.btnOpen)
        Me.gbCommands.Controls.Add(Me.btnPause)
        Me.gbCommands.Location = New System.Drawing.Point(8, 9)
        Me.gbCommands.Name = "gbCommands"
        Me.gbCommands.Size = New System.Drawing.Size(298, 123)
        Me.gbCommands.TabIndex = 25
        Me.gbCommands.TabStop = False
        Me.gbCommands.Text = "Playback Commands && Information"
        '
        'chkMute
        '
        Me.chkMute.BackColor = System.Drawing.Color.Transparent
        Me.chkMute.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.chkMute.ForeColor = System.Drawing.Color.PowderBlue
        Me.chkMute.Location = New System.Drawing.Point(119, 19)
        Me.chkMute.Name = "chkMute"
        Me.chkMute.Size = New System.Drawing.Size(126, 16)
        Me.chkMute.TabIndex = 16
        Me.chkMute.Text = "Mute - Both Channels"
        Me.chkMute.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        Me.chkMute.UseVisualStyleBackColor = False
        '
        'chkMuteRight
        '
        Me.chkMuteRight.ForeColor = System.Drawing.Color.PowderBlue
        Me.chkMuteRight.Location = New System.Drawing.Point(119, 55)
        Me.chkMuteRight.Name = "chkMuteRight"
        Me.chkMuteRight.Size = New System.Drawing.Size(126, 17)
        Me.chkMuteRight.TabIndex = 24
        Me.chkMuteRight.Text = "Mute - Right Channel"
        Me.chkMuteRight.UseVisualStyleBackColor = True
        '
        'chkMuteLeft
        '
        Me.chkMuteLeft.ForeColor = System.Drawing.Color.PowderBlue
        Me.chkMuteLeft.Location = New System.Drawing.Point(119, 41)
        Me.chkMuteLeft.Name = "chkMuteLeft"
        Me.chkMuteLeft.Size = New System.Drawing.Size(126, 17)
        Me.chkMuteLeft.TabIndex = 23
        Me.chkMuteLeft.Text = "Mute - Left Channel"
        Me.chkMuteLeft.UseVisualStyleBackColor = True
        '
        'lblPlayRate
        '
        Me.lblPlayRate.Location = New System.Drawing.Point(3, 52)
        Me.lblPlayRate.Name = "lblPlayRate"
        Me.lblPlayRate.Size = New System.Drawing.Size(81, 14)
        Me.lblPlayRate.TabIndex = 20
        Me.lblPlayRate.Text = "Play Rate: 100%"
        Me.lblPlayRate.TextAlign = System.Drawing.ContentAlignment.BottomLeft
        '
        'lblVolume
        '
        Me.lblVolume.Location = New System.Drawing.Point(3, 16)
        Me.lblVolume.Name = "lblVolume"
        Me.lblVolume.Size = New System.Drawing.Size(81, 16)
        Me.lblVolume.TabIndex = 18
        Me.lblVolume.Text = "Volume: 80%"
        Me.lblVolume.TextAlign = System.Drawing.ContentAlignment.BottomLeft
        '
        'nSpeed
        '
        Me.nSpeed.BackColor = System.Drawing.Color.LightSteelBlue
        Me.nSpeed.Location = New System.Drawing.Point(6, 64)
        Me.nSpeed.Maximum = New Decimal(New Integer() {200, 0, 0, 0})
        Me.nSpeed.Name = "nSpeed"
        Me.nSpeed.Size = New System.Drawing.Size(78, 20)
        Me.nSpeed.TabIndex = 19
        Me.nSpeed.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.nSpeed.Value = New Decimal(New Integer() {100, 0, 0, 0})
        '
        'tbPosition
        '
        Me.tbPosition.AutoSize = False
        Me.tbPosition.BackColor = System.Drawing.SystemColors.Highlight
        Me.tbPosition.Location = New System.Drawing.Point(120, 78)
        Me.tbPosition.Maximum = 100
        Me.tbPosition.Name = "tbPosition"
        Me.tbPosition.Size = New System.Drawing.Size(168, 10)
        Me.tbPosition.TabIndex = 21
        Me.tbPosition.TickStyle = System.Windows.Forms.TickStyle.None
        '
        'nVol
        '
        Me.nVol.BackColor = System.Drawing.Color.MediumPurple
        Me.nVol.Location = New System.Drawing.Point(6, 30)
        Me.nVol.Name = "nVol"
        Me.nVol.Size = New System.Drawing.Size(78, 20)
        Me.nVol.TabIndex = 17
        Me.nVol.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        Me.nVol.Value = New Decimal(New Integer() {80, 0, 0, 0})
        '
        'gbDisplays
        '
        Me.gbDisplays.Controls.Add(Me.gbWaveOnly)
        Me.gbDisplays.Controls.Add(Me.lblDeviceType)
        Me.gbDisplays.Controls.Add(Me.lblTimeRemainingMilliseconds)
        Me.gbDisplays.Controls.Add(Me.lblDurationSeconds)
        Me.gbDisplays.Controls.Add(Me.lblDurationMilliseconds)
        Me.gbDisplays.Controls.Add(Me.lblDurationNormal)
        Me.gbDisplays.Controls.Add(Me.lblBitrateKBits)
        Me.gbDisplays.Controls.Add(Me.lblTimeRemaining)
        Me.gbDisplays.Controls.Add(Me.lblTimeRemainingSeconds)
        Me.gbDisplays.Controls.Add(Me.lblPositionSeconds)
        Me.gbDisplays.Controls.Add(Me.lblPositionMilliseconds)
        Me.gbDisplays.Controls.Add(Me.lblPathFilename)
        Me.gbDisplays.Controls.Add(Me.lblPositionNormal)
        Me.gbDisplays.Controls.Add(Me.lblFileType)
        Me.gbDisplays.Controls.Add(Me.lblBitrate)
        Me.gbDisplays.Controls.Add(Me.lblDevice)
        Me.gbDisplays.Controls.Add(Me.lblStatus)
        Me.gbDisplays.ForeColor = System.Drawing.Color.Cyan
        Me.gbDisplays.Location = New System.Drawing.Point(312, 9)
        Me.gbDisplays.Name = "gbDisplays"
        Me.gbDisplays.Size = New System.Drawing.Size(315, 291)
        Me.gbDisplays.TabIndex = 22
        Me.gbDisplays.TabStop = False
        Me.gbDisplays.Text = "Audio Positions and Statistics"
        '
        'gbWaveOnly
        '
        Me.gbWaveOnly.BackColor = System.Drawing.Color.SteelBlue
        Me.gbWaveOnly.Controls.Add(Me.lblWavePositionBytes)
        Me.gbWaveOnly.Controls.Add(Me.lblBytesPerSecond)
        Me.gbWaveOnly.Controls.Add(Me.lblBitsPerSample)
        Me.gbWaveOnly.Controls.Add(Me.lblWaveDurationBytes)
        Me.gbWaveOnly.Controls.Add(Me.lblSamplesPerSecond)
        Me.gbWaveOnly.Controls.Add(Me.lblChannels)
        Me.gbWaveOnly.Location = New System.Drawing.Point(6, 208)
        Me.gbWaveOnly.Name = "gbWaveOnly"
        Me.gbWaveOnly.Size = New System.Drawing.Size(303, 77)
        Me.gbWaveOnly.TabIndex = 30
        Me.gbWaveOnly.TabStop = False
        Me.gbWaveOnly.Text = "WaveAudio Device Only! - Extended Info:"
        '
        'lblWavePositionBytes
        '
        Me.lblWavePositionBytes.AutoSize = True
        Me.lblWavePositionBytes.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblWavePositionBytes.ForeColor = System.Drawing.Color.Plum
        Me.lblWavePositionBytes.Location = New System.Drawing.Point(152, 39)
        Me.lblWavePositionBytes.Name = "lblWavePositionBytes"
        Me.lblWavePositionBytes.Size = New System.Drawing.Size(84, 13)
        Me.lblWavePositionBytes.TabIndex = 5
        Me.lblWavePositionBytes.Text = "Position: bytes"
        '
        'lblBytesPerSecond
        '
        Me.lblBytesPerSecond.AutoSize = True
        Me.lblBytesPerSecond.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBytesPerSecond.ForeColor = System.Drawing.Color.Plum
        Me.lblBytesPerSecond.Location = New System.Drawing.Point(6, 39)
        Me.lblBytesPerSecond.Name = "lblBytesPerSecond"
        Me.lblBytesPerSecond.Size = New System.Drawing.Size(114, 13)
        Me.lblBytesPerSecond.TabIndex = 1
        Me.lblBytesPerSecond.Text = "BytesPerSecond: n/a"
        '
        'lblBitsPerSample
        '
        Me.lblBitsPerSample.AutoSize = True
        Me.lblBitsPerSample.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBitsPerSample.ForeColor = System.Drawing.Color.Plum
        Me.lblBitsPerSample.Location = New System.Drawing.Point(6, 25)
        Me.lblBitsPerSample.Name = "lblBitsPerSample"
        Me.lblBitsPerSample.Size = New System.Drawing.Size(108, 13)
        Me.lblBitsPerSample.TabIndex = 0
        Me.lblBitsPerSample.Text = "BitsPerSample: n/a"
        '
        'lblWaveDurationBytes
        '
        Me.lblWaveDurationBytes.AutoSize = True
        Me.lblWaveDurationBytes.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblWaveDurationBytes.ForeColor = System.Drawing.Color.Plum
        Me.lblWaveDurationBytes.Location = New System.Drawing.Point(152, 25)
        Me.lblWaveDurationBytes.Name = "lblWaveDurationBytes"
        Me.lblWaveDurationBytes.Size = New System.Drawing.Size(88, 13)
        Me.lblWaveDurationBytes.TabIndex = 4
        Me.lblWaveDurationBytes.Text = "Duration: bytes"
        '
        'lblSamplesPerSecond
        '
        Me.lblSamplesPerSecond.AutoSize = True
        Me.lblSamplesPerSecond.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSamplesPerSecond.ForeColor = System.Drawing.Color.Plum
        Me.lblSamplesPerSecond.Location = New System.Drawing.Point(152, 52)
        Me.lblSamplesPerSecond.Name = "lblSamplesPerSecond"
        Me.lblSamplesPerSecond.Size = New System.Drawing.Size(129, 13)
        Me.lblSamplesPerSecond.TabIndex = 3
        Me.lblSamplesPerSecond.Text = "SamplesPerSecond: n/a"
        '
        'lblChannels
        '
        Me.lblChannels.AutoSize = True
        Me.lblChannels.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblChannels.ForeColor = System.Drawing.Color.Plum
        Me.lblChannels.Location = New System.Drawing.Point(6, 53)
        Me.lblChannels.Name = "lblChannels"
        Me.lblChannels.Size = New System.Drawing.Size(81, 13)
        Me.lblChannels.TabIndex = 2
        Me.lblChannels.Text = "Channels: n/a"
        '
        'lblDeviceType
        '
        Me.lblDeviceType.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblDeviceType.ForeColor = System.Drawing.Color.Thistle
        Me.lblDeviceType.Location = New System.Drawing.Point(161, 161)
        Me.lblDeviceType.Name = "lblDeviceType"
        Me.lblDeviceType.Size = New System.Drawing.Size(141, 16)
        Me.lblDeviceType.TabIndex = 29
        Me.lblDeviceType.Text = "DeviceType:"
        '
        'lblTimeRemainingMilliseconds
        '
        Me.lblTimeRemainingMilliseconds.AutoEllipsis = True
        Me.lblTimeRemainingMilliseconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblTimeRemainingMilliseconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblTimeRemainingMilliseconds.Location = New System.Drawing.Point(161, 98)
        Me.lblTimeRemainingMilliseconds.Name = "lblTimeRemainingMilliseconds"
        Me.lblTimeRemainingMilliseconds.Size = New System.Drawing.Size(141, 17)
        Me.lblTimeRemainingMilliseconds.TabIndex = 28
        Me.lblTimeRemainingMilliseconds.Text = "Time Remaining (ms):"
        '
        'lblDurationSeconds
        '
        Me.lblDurationSeconds.AutoEllipsis = True
        Me.lblDurationSeconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblDurationSeconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblDurationSeconds.Location = New System.Drawing.Point(161, 76)
        Me.lblDurationSeconds.Name = "lblDurationSeconds"
        Me.lblDurationSeconds.Size = New System.Drawing.Size(141, 17)
        Me.lblDurationSeconds.TabIndex = 27
        Me.lblDurationSeconds.Text = "Duration (sec):"
        '
        'lblDurationMilliseconds
        '
        Me.lblDurationMilliseconds.AutoEllipsis = True
        Me.lblDurationMilliseconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblDurationMilliseconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblDurationMilliseconds.Location = New System.Drawing.Point(161, 59)
        Me.lblDurationMilliseconds.Name = "lblDurationMilliseconds"
        Me.lblDurationMilliseconds.Size = New System.Drawing.Size(141, 17)
        Me.lblDurationMilliseconds.TabIndex = 26
        Me.lblDurationMilliseconds.Text = "Duration (ms):"
        '
        'lblDurationNormal
        '
        Me.lblDurationNormal.AutoEllipsis = True
        Me.lblDurationNormal.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblDurationNormal.ForeColor = System.Drawing.Color.Thistle
        Me.lblDurationNormal.Location = New System.Drawing.Point(161, 42)
        Me.lblDurationNormal.Name = "lblDurationNormal"
        Me.lblDurationNormal.Size = New System.Drawing.Size(141, 17)
        Me.lblDurationNormal.TabIndex = 25
        Me.lblDurationNormal.Text = "Duration:"
        '
        'lblBitrateKBits
        '
        Me.lblBitrateKBits.AutoEllipsis = True
        Me.lblBitrateKBits.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblBitrateKBits.ForeColor = System.Drawing.Color.Thistle
        Me.lblBitrateKBits.Location = New System.Drawing.Point(161, 190)
        Me.lblBitrateKBits.Name = "lblBitrateKBits"
        Me.lblBitrateKBits.Size = New System.Drawing.Size(141, 15)
        Me.lblBitrateKBits.TabIndex = 24
        Me.lblBitrateKBits.Text = "MP3 KBitrate: "
        '
        'lblTimeRemaining
        '
        Me.lblTimeRemaining.AutoEllipsis = True
        Me.lblTimeRemaining.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblTimeRemaining.ForeColor = System.Drawing.Color.Thistle
        Me.lblTimeRemaining.Location = New System.Drawing.Point(12, 98)
        Me.lblTimeRemaining.Name = "lblTimeRemaining"
        Me.lblTimeRemaining.Size = New System.Drawing.Size(150, 17)
        Me.lblTimeRemaining.TabIndex = 21
        Me.lblTimeRemaining.Text = "Time Remaining:"
        '
        'lblTimeRemainingSeconds
        '
        Me.lblTimeRemainingSeconds.AutoEllipsis = True
        Me.lblTimeRemainingSeconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblTimeRemainingSeconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblTimeRemainingSeconds.Location = New System.Drawing.Point(12, 115)
        Me.lblTimeRemainingSeconds.Name = "lblTimeRemainingSeconds"
        Me.lblTimeRemainingSeconds.Size = New System.Drawing.Size(150, 17)
        Me.lblTimeRemainingSeconds.TabIndex = 20
        Me.lblTimeRemainingSeconds.Text = "Time Remaining (sec):"
        '
        'lblPositionSeconds
        '
        Me.lblPositionSeconds.AutoEllipsis = True
        Me.lblPositionSeconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPositionSeconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblPositionSeconds.Location = New System.Drawing.Point(12, 76)
        Me.lblPositionSeconds.Name = "lblPositionSeconds"
        Me.lblPositionSeconds.Size = New System.Drawing.Size(150, 17)
        Me.lblPositionSeconds.TabIndex = 19
        Me.lblPositionSeconds.Text = "Position (sec):"
        '
        'lblPositionMilliseconds
        '
        Me.lblPositionMilliseconds.AutoEllipsis = True
        Me.lblPositionMilliseconds.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPositionMilliseconds.ForeColor = System.Drawing.Color.Thistle
        Me.lblPositionMilliseconds.Location = New System.Drawing.Point(12, 59)
        Me.lblPositionMilliseconds.Name = "lblPositionMilliseconds"
        Me.lblPositionMilliseconds.Size = New System.Drawing.Size(150, 17)
        Me.lblPositionMilliseconds.TabIndex = 18
        Me.lblPositionMilliseconds.Text = "Position (ms):"
        '
        'lblPathFilename
        '
        Me.lblPathFilename.AutoEllipsis = True
        Me.lblPathFilename.BackColor = System.Drawing.Color.Transparent
        Me.lblPathFilename.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPathFilename.ForeColor = System.Drawing.Color.Black
        Me.lblPathFilename.Location = New System.Drawing.Point(12, 16)
        Me.lblPathFilename.Name = "lblPathFilename"
        Me.lblPathFilename.Size = New System.Drawing.Size(290, 17)
        Me.lblPathFilename.TabIndex = 14
        Me.lblPathFilename.Text = "File:"
        Me.lblPathFilename.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblPositionNormal
        '
        Me.lblPositionNormal.AutoEllipsis = True
        Me.lblPositionNormal.BackColor = System.Drawing.Color.Transparent
        Me.lblPositionNormal.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPositionNormal.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPositionNormal.ForeColor = System.Drawing.Color.Thistle
        Me.lblPositionNormal.Location = New System.Drawing.Point(12, 42)
        Me.lblPositionNormal.Name = "lblPositionNormal"
        Me.lblPositionNormal.Size = New System.Drawing.Size(150, 17)
        Me.lblPositionNormal.TabIndex = 3
        Me.lblPositionNormal.Text = "Position: "
        Me.lblPositionNormal.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblFileType
        '
        Me.lblFileType.AutoEllipsis = True
        Me.lblFileType.BackColor = System.Drawing.Color.Transparent
        Me.lblFileType.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblFileType.ForeColor = System.Drawing.Color.Thistle
        Me.lblFileType.Location = New System.Drawing.Point(161, 145)
        Me.lblFileType.Name = "lblFileType"
        Me.lblFileType.Size = New System.Drawing.Size(141, 16)
        Me.lblFileType.TabIndex = 15
        Me.lblFileType.Text = "File Type:"
        Me.lblFileType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblBitrate
        '
        Me.lblBitrate.AutoEllipsis = True
        Me.lblBitrate.BackColor = System.Drawing.Color.Transparent
        Me.lblBitrate.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblBitrate.ForeColor = System.Drawing.Color.Thistle
        Me.lblBitrate.Location = New System.Drawing.Point(12, 189)
        Me.lblBitrate.Name = "lblBitrate"
        Me.lblBitrate.Size = New System.Drawing.Size(140, 16)
        Me.lblBitrate.TabIndex = 12
        Me.lblBitrate.Text = "MP3 Bitrate:"
        Me.lblBitrate.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblDevice
        '
        Me.lblDevice.AutoEllipsis = True
        Me.lblDevice.BackColor = System.Drawing.Color.Transparent
        Me.lblDevice.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblDevice.ForeColor = System.Drawing.Color.Thistle
        Me.lblDevice.Location = New System.Drawing.Point(11, 161)
        Me.lblDevice.Name = "lblDevice"
        Me.lblDevice.Size = New System.Drawing.Size(151, 16)
        Me.lblDevice.TabIndex = 13
        Me.lblDevice.Text = "DeviceName:"
        Me.lblDevice.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblStatus
        '
        Me.lblStatus.AutoEllipsis = True
        Me.lblStatus.BackColor = System.Drawing.Color.Transparent
        Me.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblStatus.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblStatus.ForeColor = System.Drawing.Color.Thistle
        Me.lblStatus.Location = New System.Drawing.Point(11, 145)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(151, 16)
        Me.lblStatus.TabIndex = 4
        Me.lblStatus.Text = "Status: Stopped"
        Me.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        't
        '
        Me.t.Enabled = True
        Me.t.Interval = 1000
        '
        'tRecording
        '
        Me.tRecording.Interval = 1000
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Purple
        Me.ClientSize = New System.Drawing.Size(639, 314)
        Me.Controls.Add(Me.pnl)
        Me.Font = New System.Drawing.Font("Times New Roman", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.MaximizeBox = False
        Me.Name = "frmMain"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "  csMusicMedia Library Pro - Example App"
        Me.pnl.ResumeLayout(False)
        CType(Me.picLogo, System.ComponentModel.ISupportInitialize).EndInit()
        Me.gbRecordingCommands.ResumeLayout(False)
        Me.gbRecordingCommands.PerformLayout()
        Me.gbCommands.ResumeLayout(False)
        CType(Me.nSpeed, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.tbPosition, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nVol, System.ComponentModel.ISupportInitialize).EndInit()
        Me.gbDisplays.ResumeLayout(False)
        Me.gbWaveOnly.ResumeLayout(False)
        Me.gbWaveOnly.PerformLayout()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        csMusic.stopPlay("file1")

    End Sub

    Private Sub btnPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlay.Click
        '
        'The playMusic command will open a new device with the selected filename and specified alias,
        'then it will tell the device interface to play the file. I suggest if you will not be 
        'setting a start or end point to play the file, that you just go ahead and set those 
        'parameters to '0' as I have below. 'File1' will be the alias for the device that is going to 
        'be created. Refer to 'File1' for everything you want to do with that file or what not. 
        '
        'If you want to continue using a previously setup file and device, set a new 'alias' name 
        'that is different from the one that currently exists. Thus, you can then command multiple 
        'files/instances/devices at the same time by just creating and referring to the custom 'Alias' 
        'name you have given them. Ex: 'File1', 'File2', 'WavFile' or whatever name you want to refer 
        'to that device as.
        'csMusic.playMusic("file1") ',  0,  0)
        '
        '
        'The line of code below shows how to play the file using a specific device you want to use.
        'You can actually look at the list of extensions and the device that is setup by MCI to play
        'that type of file under: "[mci extensions]" in the Win.INI file.
        'The "MPEGVideo" or "MPEGVideo2" device should be able to handle most of the popular music
        'file formats. Ex: mp3, wav, wma, ect...
        csMusic.playMusic("file1", 0, 0, "MPEGVideo")
        '
        '
        'Set the selected play rate and speed to the media. Remember to multiply the values by '10'
        'since the max for Playrate is '2000' and the max for volume is '1000'. I didn't want to have
        'to scroll the values all the way to 1000 or 2000 so that is why I made them smaller numbers'
        'and just multiply the specified numbers by '10'.
        csMusic.playRate("file1") = nSpeed.Value * 10
        csMusic.volume(csMusicMedia.volumeChannel.both, "file1") = nVol.Value * 10
        '
        'If any of the Mute checkbox controls has been checked for a previous file, then do the same for
        'this new song. You need to do this because the settings for opening the new device with the
        'newly specified file will auto-set to the default values.
        If chkMute.Checked Then

            'csMusic.muteSoundOutput(csMusicMedia.volumeChannel.both) = True

        End If

        If chkMuteLeft.Checked Then

            ' csMusic.muteSoundOutput(csMusicMedia.volumeChannel.left) = True

        End If

        If chkMuteRight.Checked Then

            ' csMusic.muteSoundOutput(csMusicMedia.volumeChannel.right) = True

        End If
        '
        tbPosition.Maximum = csMusic.duration(csMusicMedia.timeType.seconds, "file1")
        '
        'Display the Device being used to play the current media.
        lblDevice.Text = "DeviceName: " & csMusic.deviceName("file1")
        '
        'Display the type of device being used.
        lblDeviceType.Text = "DeviceType: " & csMusic.deviceType("file1")
        '
        'Setup the various Durations of the selected music media.
        lblDurationNormal.Text = "Duration: " & csMusic.duration(csMusicMedia.timeType.structured, _
            "file1")
        lblDurationMilliseconds.Text = "Duration (ms): " & csMusic.duration(csMusicMedia.timeType.milliSeconds, _
            "file1")
        lblDurationSeconds.Text = "Duration (sec): " & csMusic.duration(csMusicMedia.timeType.seconds, _
            "file1")
        '
        'Get the deviceName and check if its a WaveAudio device being used or not. The various Wave
        'statistics can only be reached if your playing a wave file AND using the 'WaveAudio' device
        'to play that wave file.
        Dim str As String = csMusic.mciDeviceDriver.WaveAudio.ToString.ToLower

        If csMusic.deviceName("file1").ToLower = str And csMusic.getSelectedFilenameExtension = _
            "wav" Then

            lblBitsPerSample.Text = "BitsPerSample: " & _
                csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.bitsPerSample, "file1").ToString

            lblBytesPerSecond.Text = "BytesPerSecond: " & _
                csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.bytesPerSecond, "file1").ToString _
                    & " bps"

            lblWaveDurationBytes.Text = "Duration: " & _
                csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.lengthInBytes, "file1").ToString _
                    & " bytes"

            lblWavePositionBytes.Text = "Position: " & _
                csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.positionInBytes, "file1").ToString _
                    & " bytes"

            lblSamplesPerSecond.Text = "SamplesPerSecond: " & _
                        csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.samplesPerSecond, _
                            "file1").ToString & " hz"

            'No need to go further since the file is a wave file using the WaveAudio driver and the 
            'Bitrate code below is for MP3's only.
            Exit Sub

        End If

        'If the current media is in MP3 format, then show the bitrate of the file in Bits and kBits.
        If csMusic.getSelectedFilenameExtension = ("mp3") Then
            '
            'Display the bitrate of the mp3 in bitsPerSecond and kilo-bitsPerSecond.
            lblBitrate.Text = "MP3 Bitrate: " & _
                csMusic.mp3Bitrate(csMusicMedia.bitrateType.bits, "file1").ToString & " bps"
            lblBitrateKBits.Text = "MP3 KBitrate: " & _
                csMusic.mp3Bitrate(csMusicMedia.bitrateType.kBits, "file1").ToString & " kbps"

        Else
            '
            'The file is not a mp3 so just display the file as 'unSupported'.
            lblBitrate.Text = "MP3 Bitrate: unSupported"
            lblBitrateKBits.Text = "MP3 Bitrate: unSupported"

        End If

    End Sub

    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click

        If btnPause.Text = "Pause" Then

            btnPause.Text = "Resume"
            csMusic.pausePlay("file1")

        Else

            btnPause.Text = "Pause"
            csMusic.resumePlay("file1")

        End If

    End Sub

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        '
        'Opens a file and then puts it in the file1 variable to be played.
        '
        openDLG = New OpenFileDialog

        openDLG.Title = _
            "Select the 'File' you want to add to the list."
        openDLG.Filter = _
            "Popular Music Files (*.mid, *.mp3, *.wav, *wma)|*.mid;*.mp3;*.wav;*.wma|Midi Files (*.mid)|*.mid|MP3 Files (*.mp3)|*.mp3|Wave Files (*.wav)|*.wav|Windows Media Audio (*.wma)|*.wma"

        If openDLG.ShowDialog = Windows.Forms.DialogResult.OK Then

            selectedFile = openDLG.FileName
            '
            '
            'The code below will setup the device and allow it to auto specify the corrent driver 
            'to use based on the file format.
            csMusic.fileToLoadAndPlay("file1", csMusicMedia.mciDeviceDriver.DefaultDevice) = _
                selectedFile
            '
            '
            'The code below will setup the device to use the 'MPEGVideo' device driver. This driver
            'should be able to play 'Most' music formats out there. As long as the correct codec is
            'installed.
            'csMusic.fileToLoadAndPlay("file1", csMusicMedia.mciDeviceDriver.MPEGVideo2) = selectedFile
            '
            '
            'The code below will setup the device to use the custom specified driver.
            'csMusic.fileToLoadAndPlay("file1", csMusicMedia.mciDeviceDriver.Custom, "MPEGVideo2") = selectedFile
            '
            '
            lblPathFilename.Text = "FileName: " & csMusic.getSelectedPathAndFilename
            '
            'Get only the file extension.
            lblFileType.Text = "FileType: " & csMusic.getSelectedFilenameExtension

        End If

    End Sub

    Private Sub t_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles t.Tick
        '
        'Keeps the 'Status' and 'Position/Duration' data updated in real-time.
        '
        If csMusic.mediaIsPlaying("file1") Then
            '
            'Return the position of the file via a Structured Format, milli-seconds, and seconds.
            '
            lblPositionNormal.Text = ("Position: " & _
                csMusic.position(csMusicMedia.timeType.structured, _
                    csMusicMedia.positionType.normal, "file1")) ' & "\" & _
            '
            lblPositionMilliseconds.Text = "Position (ms): " & _
                csMusic.position(csMusicMedia.timeType.milliSeconds, _
                    csMusicMedia.positionType.normal, "file1")
            '
            lblPositionSeconds.Text = "Position (sec): " & _
                csMusic.position(csMusicMedia.timeType.seconds, _
                    csMusicMedia.positionType.normal, "file1")
            '
            'Return the TimeRemaining of the file via a structured Format, milli-seconds, and seconds.
            '
            lblTimeRemaining.Text = "Time Remaining: " & _
                csMusic.position(csMusicMedia.timeType.structured, _
                    csMusicMedia.positionType.timeRemaining, "file1")
            '
            lblTimeRemainingMilliseconds.Text = "Time Remaining (ms): " & _
                csMusic.position(csMusicMedia.timeType.milliSeconds, _
                    csMusicMedia.positionType.timeRemaining, "file1")
            '
            lblTimeRemainingSeconds.Text = "Time Remaining (sec): " & _
                csMusic.position(csMusicMedia.timeType.seconds, _
                    csMusicMedia.positionType.timeRemaining, "file1")
            '
            'This will keep the position of the scrollbar in Sync with the position of the file.
            tbPosition.Value = csMusic.position(csMusicMedia.timeType.seconds, _
                csMusicMedia.positionType.normal, "file1")

        End If
        '
        'Go ahead and keep the status updated even if the app is idol. You can
        'of course, change this if you want to.
        lblStatus.Text = "Status: " & csMusic.mediaPlayStatus("file1")

    End Sub

    Private Sub pnl_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnl.Paint

        Dim r As New Rectangle(0, 0, pnl.Width, pnl.Height)
        Dim b As New LinearGradientBrush(r, Color.Azure, Color.DarkBlue, _
            LinearGradientMode.ForwardDiagonal)

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.FillRectangle(b, r)

    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        csMusic.closeAudioDevice(True)

    End Sub

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        Dim bit As New Bitmap(picLogo.Width, picLogo.Height)
        Dim g As Graphics = Graphics.FromImage(bit)
        Dim f As New Font("Sylfaen", 12, FontStyle.Bold Or FontStyle.Italic)
        '

        Dim txtHint As Drawing.Text.TextRenderingHint ' = TextRenderingHint.ClearTypeGridFit

        txtHint = TextRenderingHint.ClearTypeGridFit

        g.DrawString("csMusicMedia Library Professional v3.1", f, Brushes.Blue, 0, 0)
        '
        g.DrawString("By: Jason Hensley       Webpage: http://www.vbcodesource.com", New _
            Font("Sylfaen", 8, FontStyle.Italic), Brushes.Blue, 0, 35)
        '
        picLogo.Image = bit

    End Sub

    Private Sub frmMain_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Exit Sub

        Dim r As New Rectangle(0, 0, Me.Width, Me.Height)
        Dim b As New LinearGradientBrush _
            (r, Color.Violet, Color.DarkBlue, _
                LinearGradientMode.ForwardDiagonal)

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.FillRectangle(b, r)

    End Sub

    Private Sub mnuSoundControls_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)

        Dim r As New Rectangle(-2, -2, 95, 15)
        Dim b As New LinearGradientBrush(r, Color.LavenderBlush, _
            Color.DeepSkyBlue, LinearGradientMode.Vertical)

        Dim sf As StringFormat = New StringFormat

        sf.Alignment = StringAlignment.Near
        sf.LineAlignment = StringAlignment.Near

        Dim s As MenuItem = CType(sender, Object)
        '
        'The highest quality available for rendering text.
        e.Graphics.TextRenderingHint = TextRenderingHint.ClearTypeGridFit
        'The highest quality for smoothing out lines and corners.
        e.Graphics.SmoothingMode = SmoothingMode.HighQuality
        '
        e.Graphics.FillRectangle(b, New _
            Rectangle(e.Bounds.Left, e.Bounds.Top, e.Bounds.Width, _
                e.Bounds.Height))
        '
        e.Graphics.DrawString(s.Text, New Font("New Times Roman", 10, _
            FontStyle.Bold Or FontStyle.Italic), _
                New SolidBrush(Color.MediumPurple), e.Bounds.Left, _
                    e.Bounds.Top - 1.5, sf)

    End Sub

    Private Sub mnuSoundControls_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs)
        '
        'Set the hieght to 15 pixels, and the width to 95 pixels.
        e.ItemHeight = 15
        e.ItemWidth = 95

    End Sub

    Private Sub mnuAbout_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)
        '
        Dim r As New Rectangle(0, 0, 95, 15)
        Dim b As New LinearGradientBrush(r, Color.LavenderBlush, _
            Color.DeepSkyBlue, LinearGradientMode.Vertical)

        Dim sf As StringFormat = New StringFormat

        sf.Alignment = StringAlignment.Near
        sf.LineAlignment = StringAlignment.Near

        Dim s As MenuItem = CType(sender, Object)
        '
        'The highest quality available for rendering text.
        e.Graphics.TextRenderingHint = TextRenderingHint.ClearTypeGridFit
        'The highest quality for smoothing out lines and corners.
        e.Graphics.SmoothingMode = SmoothingMode.HighQuality

        e.Graphics.FillRectangle(b, New _
            Rectangle(e.Bounds.Left, e.Bounds.Top, e.Bounds.Width, _
                e.Bounds.Height))
        e.Graphics.DrawString(s.Text, New Font("New Times Roman", 10, _
            FontStyle.Bold Or FontStyle.Italic), _
                New SolidBrush(Color.BlueViolet), e.Bounds.Left, _
                    e.Bounds.Top - 0.5, sf)

    End Sub

    Private Sub mnuAbout_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs)
        '
        'Set the hieght to 15 pixels, and the width to 95 pixels
        e.ItemHeight = 15
        e.ItemWidth = 95

    End Sub

    Private Sub tbPosition_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPosition.Scroll
        '
        'This will of course change the position of the music based on the seconds value.
        csMusic.currentPositionToPlay("file1") = tbPosition.Value

    End Sub

    Private Sub nVol_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nVol.ValueChanged
        '
        '0 = Min Volume | 1000 = Max Volume
        csMusic.volume(csMusicMedia.volumeChannel.both, "file1") = (nVol.Value * 10)
        lblVolume.Text = "Volume: " & nVol.Value.ToString & "%"

    End Sub

    Private Sub chkMute_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMute.CheckedChanged

        csMusic.muteSoundOutput(csMusicMedia.volumeChannel.both, "file1") = chkMute.Checked

    End Sub

    Private Sub nSpeed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nSpeed.ValueChanged
        '
        '1000 = Normal (100%) Playback Speed.
        '0 = Resets to Normal (100%) Playback Speed.
        '
        '1 = Slowest Playback Speed.
        '2000 = Fastest Playback Speed.
        '
        csMusic.playRate("file1") = (nSpeed.Value * 10)
        lblPlayRate.Text = "Play Rate: " & nSpeed.Value.ToString & "%"

    End Sub

    Private Sub chkMuteLeft_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMuteLeft.CheckedChanged

        csMusic.muteSoundOutput(csMusicMedia.volumeChannel.left, "file1") = chkMuteLeft.Checked

    End Sub

    Private Sub chkMuteRight_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMuteRight.CheckedChanged

        csMusic.muteSoundOutput(csMusicMedia.volumeChannel.right, "file1") = chkMuteRight.Checked

    End Sub

    Friend WithEvents btnRecordingStart As System.Windows.Forms.Button
    Friend WithEvents lblDeviceType As System.Windows.Forms.Label
    Friend WithEvents btnRecordingStop As System.Windows.Forms.Button
    Friend WithEvents gbRecordingCommands As System.Windows.Forms.GroupBox
    Friend WithEvents btnSelectRecordingFile As System.Windows.Forms.Button
    Friend WithEvents lblRecordingChannels As System.Windows.Forms.Label
    Friend WithEvents lblRecordingBitsPerSample As System.Windows.Forms.Label
    Friend WithEvents lblRecordingFile As System.Windows.Forms.Label

    Private Sub btnSelectRecordingFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectRecordingFile.Click

        Dim saveDLG As SaveFileDialog = New SaveFileDialog

        saveDLG.Filter = "Wave Files (*.wav)|*.wav|All Files (*.*)|*.*"
        saveDLG.Title = "Select or create a file to save the recording too."
        '
        'Tells the dialog to throw a message to the user asking them if they want to create a new 
        'file if the selected file doesn't exist and if they select a existing file it will ask if 
        'they want to overwrite it.
        saveDLG.CreatePrompt = True
        saveDLG.OverwritePrompt = True
        '
        'Show the dialog and if the user pressed 'ok' it will execute the code in the IF statement.
        If saveDLG.ShowDialog = Windows.Forms.DialogResult.OK Then
            '
            'Set the selected filename as the file to record too.
            csMusic.recordingFileAndPAth = saveDLG.FileName '
            'Simply display the filename and path in the label control.
            lblRecordingFile.Text = "File: " & saveDLG.FileName

        End If

    End Sub

    Private Sub btnRecordingStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecordingStart.Click
        '
        'The "recordingStart" method has 3x overloaded parameters. You can choose which way to 
        'setup the recording interface. Set it to fully custom values, pre-defined quality values,
        'or use the default values.
        '
        'Setup the quality perameters for the recording device. For some reason, that I haven't 
        'really looked into yet, setting 'bytesPerSecond' doesn't seem to work right. I will try to 
        'look into it in another release or so, since it isn't 'critical'.
        Dim rec As New csMusicMedia.recordingParameters
        '
        'Set the custom settings for the recording device.
        rec.bitsPerSample = 16
        rec.bytesPerSec = 192000
        rec.channels = 2
        rec.samplesPerSec = 48000
        '
        csMusic.recordingStart(rec, "rec1")
        '
        lblRecordingBitsPerSample.Text = "BitsPerSample: " & _
            csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.bitsPerSample, "rec1")
        '
        lblRecordingBytesPerSecond.Text = "BytesPerSecond: " & _
            csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.bytesPerSecond, "rec1")
        '
        lblRecordingChannels.Text = "Channels: " & _
            csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.channels, "rec1")
        '
        lblRecordingSamplesPerSecond.Text = "SamplesPerSecond: " & _
            csMusic.waveOnlyPlaybackData(csMusicMedia.waveOnlyStatistics.samplesPerSecond, "rec1")

        tRecording.Enabled = True

    End Sub

    Private Sub btnRecordingStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecordingStop.Click

        csMusic.recordingStop("rec1")

        csMusic.recordingSave("rec1")

        tRecording.Enabled = False

    End Sub

    Private Sub lblClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Me.Close()

    End Sub

    Private Sub lblTitle_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        ' 
        If e.Button = Windows.Forms.MouseButtons.Left Then

            startPos = New Point(e.X, e.Y)

        End If

    End Sub

    Private Sub lblTitle_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        '
        'Thanks to thescarms for the move form without titlebar code below.
        '
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim mousePos As Point
            '
            ' Use the current mouse position to find the target location.
            '
            mousePos = Me.PointToScreen(New Point(e.X, e.Y))
            '
            ' Adjust the position based on where you started.
            '
            'aMoveToPoint.Offset(myPointClicked.X * -1, _
            '(myPointClicked.Y + SystemInformation.CaptionHeight + _
            'SystemInformation.BorderSize.Height) * -1)
            '
            ' Move the for
            '
            Me.Location = (mousePos - startPos)
            '
        End If

    End Sub

    Private Sub picLogo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picLogo.Click

    End Sub

    Private Sub gbRecordingCommands_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles gbRecordingCommands.Enter

    End Sub
End Class